// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.

/// When writing a match expression against `GuardrailContentFilterType`, it is important to ensure
/// your code is forward-compatible. That is, if a match arm handles a case for a
/// feature that is supported by the service but has not been represented as an enum
/// variant in a current version of SDK, your code should continue to work when you
/// upgrade SDK to a future version in which the enum does include a variant for that
/// feature.
///
/// Here is an example of how you can make a match expression forward-compatible:
///
/// ```text
/// # let guardrailcontentfiltertype = unimplemented!();
/// match guardrailcontentfiltertype {
///     GuardrailContentFilterType::Hate => { /* ... */ },
///     GuardrailContentFilterType::Insults => { /* ... */ },
///     GuardrailContentFilterType::Misconduct => { /* ... */ },
///     GuardrailContentFilterType::PromptAttack => { /* ... */ },
///     GuardrailContentFilterType::Sexual => { /* ... */ },
///     GuardrailContentFilterType::Violence => { /* ... */ },
///     other @ _ if other.as_str() == "NewFeature" => { /* handles a case for `NewFeature` */ },
///     _ => { /* ... */ },
/// }
/// ```
/// The above code demonstrates that when `guardrailcontentfiltertype` represents
/// `NewFeature`, the execution path will lead to the second last match arm,
/// even though the enum does not contain a variant `GuardrailContentFilterType::NewFeature`
/// in the current version of SDK. The reason is that the variable `other`,
/// created by the `@` operator, is bound to
/// `GuardrailContentFilterType::Unknown(UnknownVariantValue("NewFeature".to_owned()))`
/// and calling `as_str` on it yields `"NewFeature"`.
/// This match expression is forward-compatible when executed with a newer
/// version of SDK where the variant `GuardrailContentFilterType::NewFeature` is defined.
/// Specifically, when `guardrailcontentfiltertype` represents `NewFeature`,
/// the execution path will hit the second last match arm as before by virtue of
/// calling `as_str` on `GuardrailContentFilterType::NewFeature` also yielding `"NewFeature"`.
///
/// Explicitly matching on the `Unknown` variant should
/// be avoided for two reasons:
/// - The inner data `UnknownVariantValue` is opaque, and no further information can be extracted.
/// - It might inadvertently shadow other intended match arms.
///
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    ::std::clone::Clone, ::std::cmp::Eq, ::std::cmp::Ord, ::std::cmp::PartialEq, ::std::cmp::PartialOrd, ::std::fmt::Debug, ::std::hash::Hash,
)]
pub enum GuardrailContentFilterType {
    #[allow(missing_docs)] // documentation missing in model
    Hate,
    #[allow(missing_docs)] // documentation missing in model
    Insults,
    #[allow(missing_docs)] // documentation missing in model
    Misconduct,
    #[allow(missing_docs)] // documentation missing in model
    PromptAttack,
    #[allow(missing_docs)] // documentation missing in model
    Sexual,
    #[allow(missing_docs)] // documentation missing in model
    Violence,
    /// `Unknown` contains new variants that have been added since this code was generated.
    #[deprecated(note = "Don't directly match on `Unknown`. See the docs on this enum for the correct way to handle unknown variants.")]
    Unknown(crate::primitives::sealed_enum_unknown::UnknownVariantValue),
}
impl ::std::convert::From<&str> for GuardrailContentFilterType {
    fn from(s: &str) -> Self {
        match s {
            "HATE" => GuardrailContentFilterType::Hate,
            "INSULTS" => GuardrailContentFilterType::Insults,
            "MISCONDUCT" => GuardrailContentFilterType::Misconduct,
            "PROMPT_ATTACK" => GuardrailContentFilterType::PromptAttack,
            "SEXUAL" => GuardrailContentFilterType::Sexual,
            "VIOLENCE" => GuardrailContentFilterType::Violence,
            other => GuardrailContentFilterType::Unknown(crate::primitives::sealed_enum_unknown::UnknownVariantValue(other.to_owned())),
        }
    }
}
impl ::std::str::FromStr for GuardrailContentFilterType {
    type Err = ::std::convert::Infallible;

    fn from_str(s: &str) -> ::std::result::Result<Self, <Self as ::std::str::FromStr>::Err> {
        ::std::result::Result::Ok(GuardrailContentFilterType::from(s))
    }
}
impl GuardrailContentFilterType {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            GuardrailContentFilterType::Hate => "HATE",
            GuardrailContentFilterType::Insults => "INSULTS",
            GuardrailContentFilterType::Misconduct => "MISCONDUCT",
            GuardrailContentFilterType::PromptAttack => "PROMPT_ATTACK",
            GuardrailContentFilterType::Sexual => "SEXUAL",
            GuardrailContentFilterType::Violence => "VIOLENCE",
            GuardrailContentFilterType::Unknown(value) => value.as_str(),
        }
    }
    /// Returns all the `&str` representations of the enum members.
    pub const fn values() -> &'static [&'static str] {
        &["HATE", "INSULTS", "MISCONDUCT", "PROMPT_ATTACK", "SEXUAL", "VIOLENCE"]
    }
}
impl ::std::convert::AsRef<str> for GuardrailContentFilterType {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}
impl GuardrailContentFilterType {
    /// Parses the enum value while disallowing unknown variants.
    ///
    /// Unknown variants will result in an error.
    pub fn try_parse(value: &str) -> ::std::result::Result<Self, crate::error::UnknownVariantError> {
        match Self::from(value) {
            #[allow(deprecated)]
            Self::Unknown(_) => ::std::result::Result::Err(crate::error::UnknownVariantError::new(value)),
            known => Ok(known),
        }
    }
}
impl ::std::fmt::Display for GuardrailContentFilterType {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        match self {
            GuardrailContentFilterType::Hate => write!(f, "HATE"),
            GuardrailContentFilterType::Insults => write!(f, "INSULTS"),
            GuardrailContentFilterType::Misconduct => write!(f, "MISCONDUCT"),
            GuardrailContentFilterType::PromptAttack => write!(f, "PROMPT_ATTACK"),
            GuardrailContentFilterType::Sexual => write!(f, "SEXUAL"),
            GuardrailContentFilterType::Violence => write!(f, "VIOLENCE"),
            GuardrailContentFilterType::Unknown(value) => write!(f, "{}", value),
        }
    }
}
